!define CFG    `${SET}\config.ini`
!define DEFCFG `${DEFDATA}\settings\config.ini`
!define DOC    `${DATA}\Documents`
!define KEY    `SOFTWARE\Microsoft\Windows NT\CurrentVersion\FontSubstitutes`
!define INI    `$EXEDIR\${APPNAME}.ini`
!define RUS    `${APPDIR}\Skins\Russian`
!define ENG    `${APPDIR}\Skins\English`
!define DEF    `${APPDIR}\Skins\Default`

Function GetLCID
	!macro _GetLCID _LNG _LCID
		Push ${_LNG}
		Call GetLCID
		Pop ${_LCID}
	!macroend
	!define GetLCID "!insertmacro _GetLCID"
	Exch $0
	StrCmp $0 English 0 +3
	StrCpy $0 1033
		Goto EndLCID
	StrCmp $0 Russian 0 +3
	StrCpy $0 1049
		Goto +2
	StrCpy $0 1033
	EndLCID:
	Exch $0
FunctionEnd
Function GetLNG
	!macro _GetLNG _LCID _LNG
		Push ${_LCID}
		Call GetLNG
		Pop ${_LNG}
	!macroend
	!define GetLNG "!insertmacro _GetLNG"
	Exch $0
	StrCmp $0 1033 0 +3
	StrCpy $0 English
		Goto +2
	StrCpy $0 Russian
	EndLNG:
	Exch $0
FunctionEnd

${SegmentFile}
!macro OS
	Push $0
	${If} ${IsNT}
		${IfNot} ${AtLeastWinXP}
			StrCpy $0 `Windows XP`
			MessageBox MB_ICONSTOP|MB_TOPMOST `$(MINREQ)`
			Call Unload
			Quit
		${EndIf}
	${Else}
		StrCpy $0 `Windows XP`
		MessageBox MB_ICONSTOP|MB_TOPMOST `$(MINREQ)`
		Call Unload
		Quit
	${EndIf}
	Pop $0
!macroend

!macro Lang
	Push $0
	${ReadUserConfig} $0 Language
	StrCmp $0 "" 0 SetLCID
	ReadData:
	IfFileExists `${CFG}` 0 DefData
	${ConfigRead} `${CFG}` language= $0
		Goto SetLCID
	DefData:
	${ConfigRead} `${DEFCFG}` language= $0
	SetLCID:
	${GetLCID} $0 $0
	${SetEnvironmentVariable} PortableApps.comLocaleID $0
	Pop $0
!macroend

!macro LangInit
	Push $0
	ReadEnvStr $0 PortableApps.comLocaleID
	${GetLNG} $0 $0
	${SetEnvironmentVariable} PAL:LanguageCustom $0
	Pop $0
!macroend

!macro Init
	IfFileExists `${CFG}` +2
	CopyFiles /SILENT `${DEFCFG}` `${CFG}`
	IfFileExists `${DOC}` +2
	CreateDirectory `${DOC}`
!macroend

${SegmentPrePrimary}
	Push $0
	Push $1
	Push $2
	Push $3
	Push $4
	${ConfigRead} `${CFG}` outputdir= $0
	ReadEnvStr $1 PAL:LastDrive
	ReadEnvStr $2 PAL:LastPackagePartialDir
	ReadEnvStr $3 PAL:Drive
	ReadEnvStr $4 PAL:PackagePartialDir
	StrCmp $0 "" 0 Replace
	${ConfigWrite} `${CFG}` outputdir= `${DOC}` $0
		Goto Done
	Replace:
	${StrRep} `$0` `$0` `$1$2` `$3$4`
	${ConfigWrite} `${CFG}` outputdir= `$0` $0
	Done:
	ReadEnvStr $0 PAL:LanguageCustom
	StrCmp $0 Russian 0 English
	${Registry::BackupKey} `HKLM\${KEY}`
	WriteRegStr HKLM `${KEY}` Arial,0 Arial,204
	WriteRegStr HKLM `${KEY}` `Comic Sans MS,0` `Comic Sans MS,204`
	WriteRegStr HKLM `${KEY}` Courier,0 `Courier New,204`
	WriteRegStr HKLM `${KEY}` `Microsoft Sans Serif,0` `Microsoft Sans Serif,204`
	WriteRegStr HKLM `${KEY}` Tahoma,0 Tahoma,204
	WriteRegStr HKLM `${KEY}` `Times New Roman,0` `Times New Roman,204`
	WriteRegStr HKLM `${KEY}` Verdana,0 Verdana,204
	CopyFiles /SILENT `${RUS}\*.*` `${DEF}`
	Goto +2
	English:
	CopyFiles /SILENT `${ENG}\*.*` `${DEF}`
	Pop $4
	Pop $3
	Pop $2
	Pop $1
	Pop $0
!macroend

${SegmentPostPrimary}
	Push $0
	ReadEnvStr $0 PAL:LanguageCustom
	StrCmp $0 Russian 0 DeleteINIString
	${Registry::RestoreBackupKey} `HKLM\${KEY}`
	DeleteINIString:
	WriteINIStr `${INI}` ${APPNAME} Language ""
	Pop $0
!macroend